%{?scl:%scl_package eclipse-linuxtools}
%{!?scl:%global pkg_name %{name}}

%global eclipse_dropin   %{_datadir}/eclipse/dropins
%global git_version 6428ae8a121706fc446d936103db5aae14218467

Name:           %{?scl_prefix}eclipse-linuxtools
Version:        2.0.0
Release:        1%{?dist}
Summary:        Linux specific Eclipse plugins

License:        EPL
URL:            http://eclipse.org/linuxtools/
Source0:        http://git.eclipse.org/c/linuxtools/org.eclipse.linuxtools.git/snapshot/org.eclipse.linuxtools-%{version}.tar.bz2
Patch0:         remove-parent.patch
Patch1:         disable-libhover-lttng.patch
Patch2:         disable-jacoco-maven-plugin.patch
Patch3:         disable-rdt.patch
Patch4:         add-oprofile-dts-info.patch

BuildRequires: tycho
BuildRequires: tycho-extras  
BuildRequires: %{?scl_prefix}eclipse-cdt
BuildRequires: %{?scl_prefix}eclipse-jdt
BuildRequires: %{?scl_prefix}swt-chart
BuildRequires: maven-clean-plugin
BuildRequires: %{?scl_prefix}eclipse-gef

BuildArch: noarch
Obsoletes: %{?scl_prefix}eclipse-linuxprofilingframework < 2.0.0
Provides: %{?scl_prefix}eclipse-linuxprofilingframework = %{version}-%{release}

%description
The Linux Tools project is a two-faceted project. Firstly, it develops tools 
and frameworks for writing tools for Linux developers. Secondly, it provides
a place for Linux distributions to collaboratively overcome issues surrounding 
distribution packaging of Eclipse technology. The project will produce both
best practices and tools related to packaging. 

%package -n %{?scl_prefix}eclipse-changelog

Version:        2.8.1
Summary:        Eclipse ChangeLog plug-in
Epoch:          2

%description -n %{?scl_prefix}eclipse-changelog
The Eclipse ChangeLog package contains Eclipse features and plugins that are
useful for ChangeLog maintenance within the Eclipse IDE.  It includes
fragments for parsing C, C++, and Java source files to create more detailed
entries containing function or method names.

%package -n %{?scl_prefix}eclipse-rpmstubby

Summary:        Rpm spec file generator

%description -n %{?scl_prefix}eclipse-rpmstubby
RPM Stubby Plug-in is a plugin aiming to auto-generate RPM spec files.

%package -n %{?scl_prefix}eclipse-rpm-editor

Summary:  RPM Spec file editor for Eclipse
Requires: rpmlint >= 0.81
Requires: rpmdevtools

%description -n %{?scl_prefix}eclipse-rpm-editor
The Eclipse Spec file Editor package contains Eclipse plugins that are
useful for maintenance of RPM spec files within the Eclipse IDE.

%package -n %{?scl_prefix}eclipse-manpage

Summary:  Man page viewer

%description -n %{?scl_prefix}eclipse-manpage
Plugin providing common interface for displaying a man page in a view or 
fetching its content for embedded display purposes (e.g hover help).

%package -n %{?scl_prefix}eclipse-gcov

Summary:  GCov Integration

%description -n %{?scl_prefix}eclipse-gcov
Functionality to integrate GCov with the Eclipse workbench.

%package -n %{?scl_prefix}eclipse-gprof

Summary:  GProf Integration

%description -n %{?scl_prefix}eclipse-gprof
Functionality to integrate GProf with the Eclipse workbench.

%package -n %{?scl_prefix}eclipse-oprofile

Summary:  Eclipse plugin for OProfile integration
Requires: %{?scl_prefix}oprofile >= 0.9.3
Requires: usermode >= 1.98

%description -n %{?scl_prefix}eclipse-oprofile
Eclipse plugins to integrate OProfile's profiling capabilities with the CDT.

%package -n %{?scl_prefix}eclipse-perf

Summary:  Eclipse plugin for Perf integration
Requires: perf

%description -n %{?scl_prefix}eclipse-perf
Eclipse plugins to integrate Perf's profiling capabilities with the CDT.

%package -n %{?scl_prefix}eclipse-valgrind

Summary:   Valgrind Tools Integration for Eclipse
Requires:  valgrind

%description -n %{?scl_prefix}eclipse-valgrind
This package for Eclipse allows users to launch their C/C++ Development Tools
projects using the Valgrind tool suite and presents the results in the IDE. 

%package -n %{?scl_prefix}eclipse-systemtap

Summary:   Systemtap Tools Integration for Eclipse
Requires:  systemtap
Obsoletes: %{?scl_prefix}eclipse-callgraph < 2.0.0
Obsoletes: %{?scl_prefix}eclipse-systemtapgui < 1.2
Provides: %{?scl_prefix}eclipse-callgraph = %{version}-%{release}
Provides: %{?scl_prefix}eclipse-systemtapgui = 1.2

%description -n %{?scl_prefix}eclipse-systemtap
Integrate Systemtap's profiling and tracing capabilities with the CDT.


%prep
%setup -q -n org.eclipse.linuxtools-2.0.0


%patch0
%patch1 
%patch2 
%patch3 -p1
%patch4 -p1

sed -i -e 's/44/0/' profiling/org.eclipse.linuxtools.ssh.proxy/META-INF/MANIFEST.MF
sed -i -e 's/46/0/' systemtap/org.eclipse.linuxtools.systemtap.ui.ide/META-INF/MANIFEST.MF

%pom_disable_module lttng
%pom_disable_module libhover
%pom_disable_module org.eclipse.linuxtools.profiling.launch.ui.rdt.proxy profiling
%pom_disable_module org.eclipse.linuxtools.rdt.proxy profiling
%pom_disable_module org.eclipse.linuxtools.profiling.provider.tests profiling
%pom_disable_module org.eclipse.linuxtools.systemtap.ui.ide.tests systemtap
%pom_disable_module org.eclipse.linuxtools.gcov.test gcov

# Disable modules which require org.eclipse.linuxtools.profiling.tests
# to avoid the dependence.
%pom_disable_module org.eclipse.linuxtools.callgraph.launch.tests systemtap
%pom_disable_module org.eclipse.linuxtools.profiling.tests profiling
%pom_disable_module org.eclipse.linuxtools.gprof.test gprof
%pom_disable_module org.eclipse.linuxtools.oprofile.launch.tests oprofile
%pom_disable_module org.eclipse.linuxtools.perf.tests perf
%pom_disable_module org.eclipse.linuxtools.perf.swtbot.tests perf
%pom_disable_module org.eclipse.linuxtools.valgrind.cachegrind.tests valgrind
%pom_disable_module org.eclipse.linuxtools.valgrind.helgrind.tests valgrind
%pom_disable_module org.eclipse.linuxtools.valgrind.massif.tests valgrind
%pom_disable_module org.eclipse.linuxtools.valgrind.memcheck.tests valgrind
%pom_disable_module org.eclipse.linuxtools.valgrind.tests valgrind


%build
%{?scl:%scl_maven_opts}
mvn-rpmbuild clean install -Dmaven.test.skip=true -DskipTychoVersionCheck=true

pushd releng/org.eclipse.linuxtools.releng-site/target/repository/features
for f in `ls -1 . | grep jar$`; do
    unzip $f -d ${f/.jar//};
    rm -fr $f
done
popd

%install
install -d -m 755 %{buildroot}%{eclipse_dropin}

for s in changelog rpmstubby perf valgrind oprofile man rpm gcov gprof systemtap linuxtools; do
mkdir -p %{buildroot}%{eclipse_dropin}/$s/{plugins,features}
done

pushd releng/org.eclipse.linuxtools.releng-site/target/repository
#changelog
mv ./plugins/*changelog* %{buildroot}%{eclipse_dropin}/changelog/plugins
mv ./features/*changelog* %{buildroot}%{eclipse_dropin}/changelog/features
#rpmstubby
mv ./plugins/*rpmstubby* %{buildroot}%{eclipse_dropin}/rpmstubby/plugins
mv ./features/*rpmstubby* %{buildroot}%{eclipse_dropin}/rpmstubby/features

#rpm
mv ./plugins/*rpm* %{buildroot}%{eclipse_dropin}/rpm/plugins
mv ./features/*rpm* %{buildroot}%{eclipse_dropin}/rpm/features

#man
mv ./plugins/*man* %{buildroot}%{eclipse_dropin}/man/plugins
mv ./features/*man* %{buildroot}%{eclipse_dropin}/man/features

#gcov
mv ./plugins/*gcov* %{buildroot}%{eclipse_dropin}/gcov/plugins
mv ./features/*gcov* %{buildroot}%{eclipse_dropin}/gcov/features

#gprof
mv ./plugins/*gprof* %{buildroot}%{eclipse_dropin}/gprof/plugins
mv ./features/*gprof* %{buildroot}%{eclipse_dropin}/gprof/features

#perf
mv ./plugins/*perf* %{buildroot}%{eclipse_dropin}/perf/plugins
mv ./features/*perf* %{buildroot}%{eclipse_dropin}/perf/features

#valgrind
mv ./plugins/*valgrind* %{buildroot}%{eclipse_dropin}/valgrind/plugins
mv ./features/*valgrind* %{buildroot}%{eclipse_dropin}/valgrind/features

#oprofile
mv ./plugins/*oprofile* %{buildroot}%{eclipse_dropin}/oprofile/plugins
mv ./features/*oprofile* %{buildroot}%{eclipse_dropin}/oprofile/features

#systemtap
mv ./plugins/*systemtap* %{buildroot}%{eclipse_dropin}/systemtap/plugins
mv ./features/*systemtap* %{buildroot}%{eclipse_dropin}/systemtap/features
mv ./plugins/*callgraph* %{buildroot}%{eclipse_dropin}/systemtap/plugins
mv ./features/*callgraph* %{buildroot}%{eclipse_dropin}/systemtap/features

#linuxtools
mv ./plugins/* %{buildroot}%{eclipse_dropin}/linuxtools/plugins
mv ./features/* %{buildroot}%{eclipse_dropin}/linuxtools/features

popd

### oprofile install.sh stuff ###
pushd %{buildroot}%{eclipse_dropin}/oprofile/plugins
OPROFILECOREVERSION=$(ls . | grep org.eclipse.linuxtools.oprofile.core_ | sed 's/org.eclipse.linuxtools.oprofile.core_//' |sed 's/.jar//')
unzip org.eclipse.linuxtools.oprofile.core_$OPROFILECOREVERSION.jar -d ./org.eclipse.linuxtools.oprofile.core_$OPROFILECOREVERSION
rm -fr org.eclipse.linuxtools.oprofile.core_$OPROFILECOREVERSION.jar

#create opcontrol wrapper
pushd org.eclipse.linuxtools.oprofile.core_$OPROFILECOREVERSION/natives/linux/scripts
rm -f *.sh
echo '#!/bin/sh' > opcontrol
echo 'exec pkexec %{_bindir}/opcontrol ${1+"$@"}' >> opcontrol

# create DTS 2.0 OProfile policy file
cp org.eclipse.linuxtools.oprofile{,-dts2}.policy
sed -i -e 's|/usr/bin/opcontrol|%{_bindir}/opcontrol|' org.eclipse.linuxtools.oprofile-dts2.policy
sed -i -e 's|org.eclipse.linuxtools.oprofile.run-opcontrol|org.eclipse.linuxtools.oprofile-dts2.run-opcontrol|' org.eclipse.linuxtools.oprofile-dts2.policy
popd

#install opcontrol wrapper permission files
install -d -m 755 %{buildroot}%{_root_datadir}/polkit-1/actions
install -D -m 644 \
 org.eclipse.linuxtools.oprofile.core_$OPROFILECOREVERSION/natives/linux/scripts/org.eclipse.linuxtools.oprofile.policy \
%{buildroot}%{_root_datadir}/polkit-1/actions/%{?scl_prefix}org.eclipse.linuxtools.oprofile.policy
install -D -m 644 \
 org.eclipse.linuxtools.oprofile.core_$OPROFILECOREVERSION/natives/linux/scripts/org.eclipse.linuxtools.oprofile-dts2.policy \
%{buildroot}%{_root_datadir}/polkit-1/actions/%{?scl_prefix}org.eclipse.linuxtools.oprofile-dts2.policy

#remove installed files
rm -f org.eclipse.linuxtools.oprofile.core_$OPROFILECOREVERSION/natives/linux/scripts/org.eclipse.linuxtools.oprofile{,-dts2}.policy

popd


%files
%{eclipse_dropin}/linuxtools
%doc profiling/org.eclipse.linuxtools.profiling-feature/license.html
%doc profiling/org.eclipse.linuxtools.profiling-feature/epl-v10.html

%files -n %{?scl_prefix}eclipse-changelog
%{eclipse_dropin}/changelog
%doc changelog/org.eclipse.linuxtools.changelog-feature/license.html
%doc changelog/org.eclipse.linuxtools.changelog-feature/epl-v10.html

%files -n %{?scl_prefix}eclipse-rpmstubby
%{eclipse_dropin}/rpmstubby
%doc rpmstubby/org.eclipse.linuxtools.rpmstubby-feature/license.html
%doc rpmstubby/org.eclipse.linuxtools.rpmstubby-feature/epl-v10.html

%files -n %{?scl_prefix}eclipse-rpm-editor
%{eclipse_dropin}/rpm
%doc rpm/org.eclipse.linuxtools.rpm-feature/license.html
%doc rpm/org.eclipse.linuxtools.rpm-feature/epl-v10.html

%files -n %{?scl_prefix}eclipse-manpage
%{eclipse_dropin}/man
%doc man/org.eclipse.linuxtools.man-feature/license.html
%doc man/org.eclipse.linuxtools.man-feature/epl-v10.html

%files -n %{?scl_prefix}eclipse-gcov
%{eclipse_dropin}/gcov
%doc gcov/org.eclipse.linuxtools.gcov-feature/license.html
%doc gcov/org.eclipse.linuxtools.gcov-feature/epl-v10.html

%files -n %{?scl_prefix}eclipse-gprof
%{eclipse_dropin}/gprof
%doc gprof/org.eclipse.linuxtools.gprof-feature/license.html
%doc gprof/org.eclipse.linuxtools.gprof-feature/epl-v10.html

%files -n %{?scl_prefix}eclipse-oprofile
%{eclipse_dropin}/oprofile
%attr(755, root, root) %{eclipse_dropin}/oprofile/plugins/org.eclipse.linuxtools.oprofile.core_*/natives/linux/scripts/opcontrol
%{_root_datadir}/polkit-1/actions/%{?scl_prefix}org.eclipse.linuxtools.oprofile.policy
%{_root_datadir}/polkit-1/actions/%{?scl_prefix}org.eclipse.linuxtools.oprofile-dts2.policy
%doc oprofile/org.eclipse.linuxtools.oprofile-feature/license.html
%doc oprofile/org.eclipse.linuxtools.oprofile-feature/epl-v10.html

%files -n %{?scl_prefix}eclipse-perf
%{eclipse_dropin}/perf
%doc perf/org.eclipse.linuxtools.perf-feature/license.html
%doc perf/org.eclipse.linuxtools.perf-feature/epl-v10.html

%files -n %{?scl_prefix}eclipse-valgrind
%{eclipse_dropin}/valgrind
%doc valgrind/org.eclipse.linuxtools.valgrind-feature/license.html
%doc valgrind/org.eclipse.linuxtools.valgrind-feature/epl-v10.html

%files -n %{?scl_prefix}eclipse-systemtap
%{eclipse_dropin}/systemtap
%doc systemtap/org.eclipse.linuxtools.systemtap-feature/license.html
%doc systemtap/org.eclipse.linuxtools.systemtap-feature/epl-v10.html

%changelog
* Thu Jun 27 2013 Alexander Kurtakov <akurtako@redhat.com> 2.0.0-1
- Final 2.0.0 release.

* Fri Jun 07 2013 Sami Wagiaalla <swagiaal@redhat.com> 2.0.0-0.9.git6428ae8
- Update to RC3.

* Thu Jun 06 2013 Roland Grunberg <rgrunber@redhat.com> 2.0.0-0.8.git7648994
- Add information on how to use DTS 2.0 OProfile.

* Thu May 09 2013 Roland Grunberg <rgrunber@redhat.com> 2.0.0-0.7.git7648994
- Remove unnecessary installation scripts.
- Resolves #911014.

* Thu May 09 2013 Sami Wagiaalla <swagiaal@redhat.com> 2.0.0-0.7.git7648994
- Update to a new snapshot.
- Disable test modules which depend on ptp.

* Tue Apr 23 2013 Roland Grunberg <rgrunber@redhat.com> 2.0.0-0.6.gitd67d6da
- Create another OProfile policy file to be used for DTS 2.0.

* Mon Apr 22 2013 Sami Wagiaalla <swagiaal@redhat.com> 2.0.0-0.5.gitd67d6da
- Update to a new snapshot containing fix for bz 948724.

* Mon Apr 22 2013 Roland Grunberg <rgrunber@redhat.com> 2.0.0-0.4.gita645f32
- Use OProfile from SCL root.

* Thu Apr 11 2013 Alexander Kurtakov <akurtako@redhat.com> 2.0.0-0.3.gita645f32
- New snapshot containing fix for building with Ant 1.9.

* Wed Apr 10 2013 Alexander Kurtakov <akurtako@redhat.com> 2.0.0-0.2.gitaa6d235
- SCL-ize.
- Update to newer snapshot.

* Wed Mar 27 2013 Alexander Kurtakov <akurtako@redhat.com> 2.0.0-0.1.git95aacfe
- Update to 2.0.0 prerelease for Kepler compatibility.
- Changelog no longer has it's own release as the version bumped.

* Wed Feb 13 2013 Roland Grunberg <rgrunber@redhat.com> 1.2.0-3
- Build as noarch.

* Thu Jan 24 2013 Roland Grunberg <rgrunber@redhat.com> 1.2.0-3
- Properly package PolicyKit for Eclipse OProfile.

* Fri Dec 7 2012 Roland Grunberg <rgrunber@redhat.com> 1.2.0-2
- Make changes to build in SCL environment.
- Disable bundles that depend on Eclipse PTP, and SWTBot.

* Fri Nov 23 2012 Roland Grunberg <rgrunber@redhat.com> 1.2.0-1
- Update to 1.2.0 upstream release.
- Disable jacoco-maven-plugin.

* Fri Oct 5 2012 Roland Grunberg <rgrunber@redhat.com> 1.1.1-3
- Synchronize release number for subpackages and rebuild.

* Fri Oct 5 2012 Roland Grunberg <rgrunber@redhat.com> 1.1.1-2
- Bump release to avoid conflicting with previous build.

* Tue Oct 2 2012 Roland Grunberg <rgrunber@redhat.com> 1.1.1-1
- Update to 1.1.1 upstream release.

* Wed Aug 8 2012 Alexander Kurtakov <akurtako@redhat.com> 1.1.0-1
- Initial packaging.

